<?php

namespace App\Tasks;

use App\Database\UpdateMassive2;
use App\Models\Transaction;
use Carbon\Carbon;
use Illuminate\Support\Collection;

class UpdateMassive5Task
{
    public function handle(): void
    {
        Transaction::query()
            ->select([
                'id',
                'date',
                'value',
            ])
            ->where('id', '>', 0)
            ->chunkById(1000, function ($transactions) {

                /** @var Collection $transactions */
                foreach ($transactions as $transaction) {
                    $transaction->date = Carbon::now()->subDays(random_int(1, 3));
                    $transaction->value = 10 + random_int(0, 10);

                    $config[] = [
                        'primary_key' => $transaction->id,
                        'columns' => [
                            'date' => "'$transaction->date'::timestamp",
                            'value' => $transaction->value,
                        ]
                    ];
                }

                $updateMassive2 = new UpdateMassive2();
                $updateMassive2->apply('transactions', 'id', $config);
            });
    }
}
